﻿using Microsoft.Toolkit.Uwp.Notifications;
using System;
using System.IO;
using System.Windows;
using Windows.Foundation.Collections;

namespace TEST_WpfNotification {
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window {

        private string m_imgKaru = Path.GetFullPath(@"Assets\karu.jpg");
        private string m_imgDeepRockGalactic = Path.GetFullPath(@"Assets\deeprockgalactic.jpg");

        public MainWindow() {
            InitializeComponent();
            ToastNotificationManagerCompat.OnActivated += ToastNotificationManagerCompat_OnActivated;
        }

        private void ToastNotificationManagerCompat_OnActivated(ToastNotificationActivatedEventArgsCompat toastArgs) {
            // Obtain the arguments from the notification
            ToastArguments args = ToastArguments.Parse(toastArgs.Argument);

            // Obtain any user input (text boxes, menu selections) from the notification
            ValueSet userInput = toastArgs.UserInput;

            // Need to dispatch to UI thread if performing UI operations
            Application.Current.Dispatcher.Invoke(delegate {
                // TODO: Show the corresponding content
                MessageBox.Show("Toast activated. Args: " + toastArgs.Argument);
            });
        }

        private void Button_Click(object sender, RoutedEventArgs e) {
            new ToastContentBuilder()
               .AddText("알림 제목")
               .AddText("본?문")
               .Show();
        }

        private void Button_Click_1(object sender, RoutedEventArgs e) {
            new ToastContentBuilder()
               .AddText("알림 제목")
               .AddText("본?문")
               .AddHeroImage(new Uri(m_imgDeepRockGalactic))
               .Show();
        }

        private void Button_Click_2(object sender, RoutedEventArgs e) {
            new ToastContentBuilder()
              .AddText("알림 제목")
              .AddText("본?문")
              .AddAppLogoOverride(new Uri(m_imgKaru), ToastGenericAppLogoCrop.Circle)
              .AddHeroImage(new Uri(m_imgDeepRockGalactic))
              .AddArgument("action", "reply")
              .Show();
        }

        private void Button_Click_3(object sender, RoutedEventArgs e) {
            new ToastContentBuilder()
              .AddText("알림 제목")
              .AddText("본?문")
              .AddAppLogoOverride(new Uri(m_imgKaru), ToastGenericAppLogoCrop.Circle)
              .AddHeroImage(new Uri(m_imgDeepRockGalactic))
              .AddInputTextBox("peko", placeHolderContent: "폐하의 이름을 사칭한 괘씸한 놈 죽어라")

                // Buttons
                .AddButton(new ToastButton()
                    .SetContent("배신")
                    .AddArgument("action", "betrayal")
                    .SetBackgroundActivation())

                .AddButton(new ToastButton()
                    .SetContent("캐르릉")
                    .AddArgument("action", "Meow")
                    .SetBackgroundActivation())

                .AddButton(new ToastButton()
                    .SetContent("배신")
                    .AddArgument("action", "betrayal")
                    .SetBackgroundActivation())
              .Show();
        }
    }
}
